/* Declare camera system component. Used to define location and
orientation of objects in space. */



#include "../defs.h"

#include "../node.h"

#include "../list.h"

#include "../map.h"

#include "../polygon.h"

#include "../nodepol.h"

#include "../nodeint.h"

#include "../nodeflo.h"

#include "../nodexyz.h"

#include "../math.h"

#include "../mesh.h"

#include "../refsys.h"

#include "../camsys.h"

#include "nodecomp.h"

#include "cocamsys.h"



/* contructor - init with default component type
**********************************************************/
CComponentCameraSystem::CComponentCameraSystem ()
{
   m_dwMyTypeID = TYPE_CAMSYS;
}



/* Alocate data
pData1 - not used
pData2 - a CList pointer with initial parameters for
         the reference system (nodes type CNodeFloat)
         (THE FIRST ELEMENT IN THE LIST IS NOT USED)
         If NULL (0), doesn't initialise.
return TRUE - ok / FALSE - error
**********************************************************/
PTRVAL CComponentCameraSystem::mCreate ( PTRVAL pData1, PTRVAL pData2 )
{
   pData1 = pData1;        // to avoid GCC warnings

   // the parameters list (THE FIRST ELEMENT ISN'T A PARAMETER)
   CList
      *poList = (CList*) pData2;
   // if list doesn't exist
   if ( poList == NULL )
      return TRUE;

   // define reference system position and orientation
   // position
   // REVIEW -> os - abaixo podem causar problemas em outros SR?
   m_oCamSys.m_stPos.fX = - ( (INT) ( (CNodeFloat*) poList->mRetNode ( 2 ) )->m_fValue << SCALEEXP ); // == nX * power(2,SCALEEXP)
   m_oCamSys.m_stPos.fY = - ( (INT) ( (CNodeFloat*) poList->mRetNode ( 3 ) )->m_fValue << SCALEEXP );
   m_oCamSys.m_stPos.fZ =   ( (INT) ( (CNodeFloat*) poList->mRetNode ( 4 ) )->m_fValue << SCALEEXP );
   // orientation
   
   /* under construction CONTINUE
   tagfXYZ
      stDirection;
   stDirection.fX = ( (CNodeFloat*) poList->mRetNode ( 5 ) )->m_fValue;
   stDirection.fY = ( (CNodeFloat*) poList->mRetNode ( 6 ) )->m_fValue;
   stDirection.fZ = ( (CNodeFloat*) poList->mRetNode ( 7 ) )->m_fValue;
   m_oCamSys.m_oM.mSetViewBase ( stDirection, m_oCamSys );*/
   
   m_oCamSys.m_stI.fX = ( (CNodeFloat*) poList->mRetNode ( 5 ) )->m_fValue;
   m_oCamSys.m_stI.fY = ( (CNodeFloat*) poList->mRetNode ( 6 ) )->m_fValue;
   m_oCamSys.m_stI.fZ = ( (CNodeFloat*) poList->mRetNode ( 7 ) )->m_fValue;
   m_oCamSys.m_stJ.fX = ( (CNodeFloat*) poList->mRetNode ( 8 ) )->m_fValue;
   m_oCamSys.m_stJ.fY = ( (CNodeFloat*) poList->mRetNode ( 9 ) )->m_fValue;
   m_oCamSys.m_stJ.fZ = ( (CNodeFloat*) poList->mRetNode ( 10 ) )->m_fValue;
   m_oCamSys.m_stK.fX = ( (CNodeFloat*) poList->mRetNode ( 11 ) )->m_fValue;
   m_oCamSys.m_stK.fY = ( (CNodeFloat*) poList->mRetNode ( 12 ) )->m_fValue;
   m_oCamSys.m_stK.fZ = ( (CNodeFloat*) poList->mRetNode ( 13 ) )->m_fValue;

   return TRUE;
}
